config/routes.rb
Rails.application.routes.draw do
  root "dashboard#index"
  resources :basic_informations
  resources :infrastructures
  
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    passwords: 'users/passwords',
    registrations: 'users/registrations'
  }
end

app/models/infrastructure.rb
class Infrastructure < ApplicationRecord
end

app/controllers/infrastructures_controller.rb
class InfrastructuresController < ApplicationController
  before_action :set_infrastructure, only: %i[ show edit update destroy ]

  def index
    @infrastructures = Infrastructure.all.order(created_at: :desc)
  end

  def show
  end

  def new
    @infrastructure = Infrastructure.new
  end

  def edit
  end

  def create
    @infrastructure = Infrastructure.new(infrastructure_params)
    @infrastructure.user_id = current_user.id
    respond_to do |format|
      if @infrastructure.save
        format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully created." }
        format.json { render :show, status: :created, location: @infrastructure }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @infrastructure.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @infrastructure.update(infrastructure_params)
        format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully updated." }
        format.json { render :show, status: :ok, location: @infrastructure }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @infrastructure.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @infrastructure.destroy
    respond_to do |format|
      format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_infrastructure
      @infrastructure = Infrastructure.find_by(id: params[:id])
    end

    # Only allow a list of trusted parameters through.
    def infrastructure_params
      params.require(:infrastructure).permit(:land_availability, :main_campus, :pg_center_1, :pg_center_2, :pg_center_3, :no_of_class_rooms, :no_of_labs)
    end
end

app/helpers/infrastructures_helper.rb
module InfrastructuresHelper
end

app/views/infrastructures/_form.html.erb
<%= simple_form_for(@infrastructure) do |f| %>
  <%= f.error_notification %>

  <div class="form-inputs">
    <div class="row">
      <%= f.input :land_availability %>
      <div class="col-md-6">
        <%= f.input :main_campus %>
        <%= f.input :pg_center_2 %>
        <%= f.input :no_of_class_rooms %>
      </div>
      <div class="col-md-6">
        <%= f.input :pg_center_1 %>
        <%= f.input :pg_center_3 %>
        <%= f.input :no_of_labs %>
      </div>
    </div>
  </div>

  <br>
  <div class="form-actions">
    <%= link_to "Back", infrastructures_path, class: "btn btn-primary btn-sm btn-blue" %>
    <%= f.button :submit, class: "btn btn-primary btn-sm btn-blue" %>
  </div>
<% end %>

app/views/infrastructures/edit.html.erb
<h4 class="mb-3 mt-3">Editing infrastructure</h4>

<%= render "form", infrastructure: @infrastructure %>

app/views/infrastructures/index.html.erb
<h4 class="mb-3 mt-3">Infrastructure List</h4>
<%= link_to "Add Infrastructure", new_infrastructure_path, class: "btn btn-primary btn-sm btn-blue" %>
<br>
<br>
<div class="table-responsive">
  <table class="table table-bordered">
    <thead>
      <tr>
        <th scope="col">Land Availability</th>
        <th scope="col">Main Campus </th>
        <th scope="col">PG Center I</th>
        <th scope="col">PG Center II</th>
        <th scope="col">PG Center III</th>
        <th scope="col">No. of Class Rooms</th>
        <th scope="col">No. of Labs</th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody>
      <% @infrastructures.each do |infra| %>
        <tr>
          <td><%= infra.land_availability %></td>
          <td><%= infra.main_campus %></td>
          <td><%= infra.pg_center_1 %></td>
          <td><%= infra.pg_center_3 %></td>
          <td><%= infra.pg_center_3 %></td>
          <td><%= infra.no_of_class_rooms %></td>
          <td><%= infra.no_of_labs %></td>
          <td>
            <%= link_to "Edit", edit_infrastructure_path(infra.id), class: "btn btn-primary btn-sm btn-blue" %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/infrastructures/new.html.erb
<h4 class="mb-3 mt-3">New infrastructure</h4>
<%= render "form", infrastructure: @infrastructure %>

app/views/infrastructures/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @infrastructure %>

<div>
  <%= link_to "Edit this infrastructure", edit_infrastructure_path(@infrastructure) %> |
  <%= link_to "Back to infrastructures", infrastructures_path %>

  <%= button_to "Destroy this infrastructure", @infrastructure, method: :delete %>
</div>